//
//  Onigiri.m
//  onitest
//
//  Created by dev on 10/05/12.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <dlfcn.h>
#import "Onigiri.h"

unsigned char charLength[256] = {
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	//ここまでで7F
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	//ここまででBF
	2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
	2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
	//ここまででDF
	3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,
	//ここまででEF
	4,4,4,4,4,4,4,4,
	//ここまででF7
	5,5,5,5,
	//ここまででFB
	6,6,
	//ここまででFD
	1,1
	//FEとFF
};

typedef int (*FPT_ONIG_NEW)(OnigRegex*, const OnigUChar *, const OnigUChar *, OnigOptionType, OnigEncoding, OnigSyntaxType *, OnigErrorInfo *);
typedef int (*FPT_ONIG_ERROR_CODE_TO_STR)(OnigUChar *, int, ...);
typedef OnigRegion *(*FPT_ONIG_REGION_NEW)(void);
typedef int (*FPT_ONIG_SEARCH)(OnigRegex, const OnigUChar *, const OnigUChar *, const OnigUChar *, const OnigUChar *, OnigRegion *, OnigOptionType);
typedef void (*FPT_ONIG_REGION_FREE)(OnigRegion *, int);
typedef void (*FPT_ONIG_FREE)(OnigRegex);
typedef int (*FPT_ONIG_END)(void);

FPT_ONIG_NEW p_onig_new = NULL;
FPT_ONIG_REGION_NEW p_onig_region_new = NULL;
FPT_ONIG_ERROR_CODE_TO_STR p_onig_error_code_to_str = NULL;
FPT_ONIG_SEARCH p_onig_search = NULL;
FPT_ONIG_REGION_FREE p_onig_region_free = NULL;
FPT_ONIG_FREE p_onig_free = NULL;
FPT_ONIG_END p_onig_end = NULL;

OnigEncodingType *p_OnigEncodingASCII = NULL;
OnigSyntaxType *p_OnigSyntaxRuby = NULL;


void *entryPoint = NULL;
int refCounter = 0;//dll自体の参照カウントであればdlopenとdlCloseで管理されている

OnigUChar errorMessage[ONIG_MAX_ERROR_MESSAGE_LEN];
int NewRegix(regex_t **reg, NSString *pattern)
{
	OnigErrorInfo einfo;
	const OnigUChar *ptn = (const OnigUChar *)[pattern UTF8String];
	int result = (*p_onig_new)(reg, ptn, ptn + strlen((char *)ptn), 
							   ONIG_OPTION_DEFAULT, p_OnigEncodingASCII, 
							   p_OnigSyntaxRuby, &einfo);
	
	if(result != ONIG_NORMAL)
	{
		(*p_onig_error_code_to_str)(errorMessage, result, &einfo);
		return ONIGIRI_ERROR;
	}
	
	return ONIGIRI_SUCCESS;
}




@implementation OnigiriRange
@synthesize begin, end;
@end





@implementation Onigiri

-(id)init
{
	[super init];

	if(refCounter == 0 && entryPoint != NULL)
	{
		lastError = @"リファレンスカウンター異常";
		return self;
	}
	
	if(refCounter == 0)
	{
		NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
		NSBundle *mainBundle = [NSBundle mainBundle];
		NSString *frameworkPath = [mainBundle privateFrameworksPath];

		entryPoint = dlopen([[frameworkPath stringByAppendingPathComponent:@"libonig.2.dylib"] UTF8String], RTLD_NOW);
		
		p_onig_new = [self private_dlsymWrap:"onig_new"];
		p_onig_region_new = [self private_dlsymWrap:"onig_region_new"];
		p_onig_error_code_to_str = [self private_dlsymWrap:"onig_error_code_to_str" ];
		p_onig_search = [self private_dlsymWrap:"onig_search" ];
		p_onig_region_free = [self private_dlsymWrap:"onig_region_free"];
		p_onig_free = [self private_dlsymWrap:"onig_free" ];
		p_onig_end = [self private_dlsymWrap:"onig_end"];
		
		p_OnigEncodingASCII = [self private_dlsymWrap:"OnigEncodingASCII"];
		p_OnigSyntaxRuby = [self private_dlsymWrap:"OnigSyntaxRuby"];
		
		[pool release];
	}
	
	refCounter++;
	return self;
}



-(void)dealloc
{	
	refCounter--;
	
	if(refCounter == 0)
	{
		dlclose(entryPoint);
		
		entryPoint = NULL;
		
		p_onig_new = NULL;
		p_onig_region_new = NULL;
		p_onig_error_code_to_str = NULL;
		p_onig_search = NULL;
		p_onig_region_free = NULL;
		p_onig_free = NULL;
		p_onig_end = NULL;
		
		p_OnigEncodingASCII = NULL;
		p_OnigSyntaxRuby = NULL;
	}
	
	[super dealloc];
}



-(int)search:(NSString *)str pattern:(NSString *)pat result:(NSMutableArray **)posList
{
	regex_t *searchReg;

	int result = NewRegix(&searchReg, pat);
	if(result != ONIGIRI_SUCCESS)
	{
		lastError = [NSString stringWithUTF8String:(char *)errorMessage];
		return ONIGIRI_ERROR;
	}
	
	OnigRegion *region = (*p_onig_region_new)();

	const OnigUChar *start = (const OnigUChar *)[str UTF8String];
	const OnigUChar *end   = (const OnigUChar *)(start + strlen([str UTF8String]));
	const OnigUChar *range = end;
	const OnigUChar *point = start;
	*posList = [[[NSMutableArray alloc] init] autorelease];
	result = (*p_onig_search)(searchReg, start, end, point, range, region, ONIG_OPTION_NONE);
	if(result >= 0)
	{
		
		int i;
		for(i = 0 ; i < region->num_regs ; i++)
		{
			OnigiriRange *o_range = [[[OnigiriRange alloc] init] autorelease];
			o_range->begin = region->beg[i];
			o_range->end   = region->end[i];
			[*posList addObject:o_range];
				
			point = start + region->end[i];
		}
	}
	else if(result == ONIG_MISMATCH)
	{
	}
	else 
	{//error
		OnigErrorInfo einfo;
		(*p_onig_error_code_to_str)(errorMessage, result, &einfo);
		return ONIGIRI_ERROR;
	}
		
	

	(*p_onig_region_free)(region, 1 );// 1:free self, 0:free contents only 
	(*p_onig_free)(searchReg);
	(*p_onig_end)();
	
	
	return ONIGIRI_SUCCESS;
}



-(NSString *)getLastError
{
	return lastError;
}



-(void *)private_dlsymWrap:(char *)symbol
{
	dlerror();
	void *r = dlsym(entryPoint, symbol);
	char *e = dlerror();
	
	if (e) 
	{
		lastError = [NSString stringWithUTF8String:e];
		return NULL;
	}
	
	return r;
}


@end
